;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    .include "sa.inc" ; hardware registers for particular CPU chip being used

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.section .libc, code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Hard-coded delay function for use in error handling routines
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 .global _Delay_Code_msec

_Delay_Code_msec:

    ; @  5 MHz (10 MHz xtal), 1 cycle =  .20 usec -> 1 msec =  5000 cycles
    ; @ 10 MHz (PLL),         1 cycle =  .04 usec -> 1 msec = 10000 cycles
    ; @ 20 MHz (PLL),         1 cycle =  .05 usec -> 1 msec = 20000 cycles
    ; @ 40 MHz (PLL),         1 cycle = .025 usec -> 1 msec = 40000 cycles

    ; calc number_of_cycles/4 for 1 msec
    mov     #(125*XTAL_MHZ), w1 ; assume no PLL (fCyc = fXTAL / 2)
    btsc    OSCCON,#12          ; test for PLL engaged
    mov     #(250*CPU_MIPS), w1 ; PLL is engaged (fCyc = fMIPS)

    ; w0 = number of msecs to delay (must be > 0)
_DO:
    dec     w0, w0
    bra     z, _DONE
    ; delay 1 msec
    mov     w1, w2
_1MSEC: ; 4 cycles
    nop
    dec     w2, w2
    bra     nz, _1MSEC
    bra     _DO

_DONE:
    return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
