;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.section .libdsp, code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; _iSqrt: Calculate square root [of an integer value]
;
; Input:
;	w0 = input value
; Return:
;	w0 = square root of input value
;
; System resources usage:
;	{w0..w3}	used, not restored
;
; DO and REPEAT instruction usage.
;	no DO intruction
;	no REPEAT intructions
;
;............................................................................

 .global _iSqrt;

_iSqrt:

;............................................................................

    clr     w2            ; "res"
    mov     #(1<<14), w1  ; "one"

_WHILE1: ; WHILE (w1 > w0) w1 >>= 2;

    cp      w1, w0
    bra     leu, _ENDWHILE1

    lsr     w1,#2,w1    ; w1 >>= 2
    bra     _WHILE1

_ENDWHILE1:

_WHILE2: ; WHILE (w1 != 0)

    cp0     w1
    bra     z, _ENDWHILE2

    ; if (v >= res + one) { v -= res + one;  res += one << 1; }
    add     w2,w1,w3    ; res + one
    cp      w0, w3
    bra     ltu, _IF2
    sub     w0,w3,w0    ; v -= res + one
    sl      w1,#1,w3
    add     w2,w3,w2    ; res += one << 1
_IF2:

    ; res >> 1;
    lsr     w2,#1,w2

    ; one >> 2;
    lsr     w1,#2,w1

    bra     _WHILE2

_ENDWHILE2:

    mov     w2, w0      ; return res

;............................................................................

    return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
