library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

use work.User_App_comp.all;

entity Memory_Decoder is

  port (
    Mem_Address_in : in  std_logic_vector(15 downto 0);
    MRD_in         : in  std_logic;
    MWR_in         : in  std_logic;
    Mem_Sel_out    : out std_logic;
    MWait_out      : out std_logic;
    RAM_WR_out     : out std_logic);

end Memory_Decoder;

architecture arch_Memory_Decoder of Memory_Decoder is

  signal Mem_Address : std_logic_vector(15 downto 0);
  signal MRD         : std_logic;
  signal MWR         : std_logic;
  signal Mem_Sel     : std_logic;
  signal MWait       : std_logic;
  signal RAM_WR      : std_logic;

begin  -- arch_Memory_Decoder

  Mem_Address <= Mem_Address_in;
  MRD         <= MRD_in;
  MWR         <= MWR_in;

  Mem_Sel_out <= Mem_Sel;
  MWait_out   <= MWait;
  RAM_WR_out  <= RAM_WR;

  MWait <= '1';

  Mem_Sel <= '0' when ((Mem_Address >= X"0000") and (Mem_Address <= X"007F"))   else
             '1' when ((Mem_Address >= X"FF80") and (Mem_Address <= X"FFFF")) else
             '0';

  RAM_WR <= '1' when ((Mem_Address >= X"FF80") and (Mem_Address <= X"FFFF") and MWR = '1') else
            '0';


end arch_Memory_Decoder;
