library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity RAM_128dx16w is

  port (
    Clock_in   : in  std_logic;
    Address_in : in  std_logic_vector(6 downto 0);
    DI_in      : in  std_logic_vector(15 downto 0);
    WE_in      : in  std_logic;
    DO_out     : out std_logic_vector(15 downto 0));

end RAM_128dx16w;

architecture arch_RAM_128dx16w of RAM_128dx16w is

  signal Clock   : std_logic;
  signal Address : std_logic_vector(6 downto 0);
  signal DI      : std_logic_vector(15 downto 0);
  signal WE      : std_logic;
  signal DO      : std_logic_vector(15 downto 0);

  constant RAM_DEPTH      : integer := 128;
  constant RAM_WORD_WIDTH : integer := 16;

  type RAM_type is array (0 to (RAM_DEPTH - 1)) of std_logic_vector((RAM_WORD_WIDTH - 1) downto 0);

-----------------------------------------------------------------------------
  signal RAM : RAM_type :=
    (
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000");
-----------------------------------------------------------------------------

begin  -- arch_RAM_128dx16w

  Clock   <= Clock_in;
  Address <= Address_in;
  WE      <= WE_in;
  DI      <= DI_in;

  DO_out <= DO;

  DO <= RAM(conv_integer(Address(6 downto 0)));

  U1 : process (Clock)
  begin

    if Clock'event and Clock = '1' then

      if WE = '1' then

        RAM(conv_integer(Address(6 downto 0))) <= DI;

      end if;  -- if WE = '1'
    end if;  -- if Clock'event and Clock = '1'

  end process U1;

end arch_RAM_128dx16w;


