library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity ROM_128dx16w is

  port (
    Address_in : in  std_logic_vector(6 downto 0);
    DO_out     : out std_logic_vector(15 downto 0));

end ROM_128dx16w;

architecture arch_ROM_128dx16w of ROM_128dx16w is

  signal Address : std_logic_vector(6 downto 0);
  signal DO      : std_logic_vector(15 downto 0);

  constant ROM_DEPTH      : integer := 128;
  constant ROM_WORD_WIDTH : integer := 16;

  type ROM_type is array (0 to (ROM_DEPTH - 1)) of std_logic_vector((ROM_WORD_WIDTH - 1) downto 0);

-----------------------------------------------------------------------------
  signal ROM : ROM_type :=
    (
      X"8A00", X"FFFF", X"9200", X"0070",
      X"0200", X"0000", X"0208", X"FFFF",
      X"0210", X"FF80", X"0610", X"0000",
      X"0218", X"0010", X"A800", X"5610",
      X"FFFF", X"BA00", X"0015", X"B200",
      X"000F", X"A000", X"0610", X"0000",
      X"1B00", X"7A08", X"0020", X"0801",
      X"8018", X"A800", X"B200", X"000F",
      X"0610", X"FFFF", X"7A18", X"0030",
      X"D000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0610", X"FFFF", X"7A38", X"0030",
      X"D000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000",
      X"0000", X"0000", X"0000", X"0000");
-----------------------------------------------------------------------------

begin  -- arch_ROM_128dx16w

  Address <= Address_in;
  
--   DO_out <= DO;
  
  DO_out <= ROM(conv_integer(Address(6 downto 0)));

end arch_ROM_128dx16w;


