library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library unisim;
use unisim.vcomponents.all;

use work.S3_IF_comp.all;

entity DISP_IF is
  port (
    Segment_A_input   : in  std_logic;
    Segment_B_input   : in  std_logic;
    Segment_C_input   : in  std_logic;
    Segment_D_input   : in  std_logic;
    Segment_E_input   : in  std_logic;
    Segment_F_input   : in  std_logic;
    Segment_G_input   : in  std_logic;
    Segment_DP_input  : in  std_logic;
    Segment_AN_input  : in  std_logic_vector(3 downto 0);
    Segment_A_output  : out std_logic;
    Segment_B_output  : out std_logic;
    Segment_C_output  : out std_logic;
    Segment_D_output  : out std_logic;
    Segment_E_output  : out std_logic;
    Segment_F_output  : out std_logic;
    Segment_G_output  : out std_logic;
    Segment_DP_output : out std_logic;
    Segment_AN_output : out std_logic_vector(3 downto 0));
end DISP_IF;

architecture arch_DISP_IF of DISP_IF is

begin  -- arch_DISP_IF

  UA : OBUF
    port map (
      I => Segment_A_input,
      O => Segment_A_output);

  UB : OBUF
    port map (
      I => Segment_B_input,
      O => Segment_B_output);

  UC : OBUF
    port map (
      I => Segment_C_input,
      O => Segment_C_output);

  UD : OBUF
    port map (
      I => Segment_D_input,
      O => Segment_D_output);

  UE : OBUF
    port map (
      I => Segment_E_input,
      O => Segment_E_output);

  UF : OBUF
    port map (
      I => Segment_F_input,
      O => Segment_F_output);

  UG : OBUF
    port map (
      I => Segment_G_input,
      O => Segment_G_output);

  UDP : OBUF
    port map (
      I => Segment_DP_input,
      O => Segment_DP_output);

  Segment_AN_Loop : for Segment_AN_index in 0 to 3 generate

    obuf_Segment_AN : OBUF
      port map (
        I => Segment_AN_input(Segment_AN_index),
        O => Segment_AN_output(Segment_AN_index));

  end generate Segment_AN_Loop;

end arch_DISP_IF;
