library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

library unisim;
use unisim.vcomponents.all;

use work.S3_IF_comp.all;

entity SW_IF is
  port (
    Slider_Switch_input  : in  std_logic_vector(7 downto 0);
    PB_Switch_input      : in  std_logic_vector(3 downto 0);
    Slider_Switch_output : out std_logic_vector(7 downto 0);
    PB_Switch_output     : out std_logic_vector(3 downto 0));
end SW_IF;

architecture arch_SW_IF of SW_IF is

begin  -- arch_SW_IF

  Slider_Switch_Loop : for Slider_SW_index in 0 to 7 generate

    ibuf_Slider_Switch : ibuf
      port map (
        i => Slider_Switch_input(Slider_SW_index),
        o => Slider_Switch_output(Slider_SW_index));

  end generate Slider_Switch_Loop;

  Pushbutton_Switch_Loop : for PB_SW_index in 0 to 3 generate

    ibuf_PB_Switch : ibuf
      port map (
        i => PB_Switch_input(PB_SW_index),
        o => PB_Switch_output(PB_SW_index));

  end generate Pushbutton_Switch_Loop;

end arch_SW_IF;
