#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>

#define MAX_WIDTH        256
#define STR_WIDTH        MAX_WIDTH / 4
#define ADDRESS_SPACE    4096
#define ARRAY_SIZE       8
#define BUF_SIZE         256
#define NUM_BUFS         4

#define USAGE_ERROR       101
#define INFILE_ERROR      102
#define OUTFILE_ERROR     103
#define NULL_STRING_ERROR 104

char * parse(char * src_str, char * dest_str);
void chop( char * src_str);

main(int argc, char * argv[])
{

     char * residue;
     char in_buffer[BUF_SIZE];
     char dest_str[BUF_SIZE];
     char microword_array[ADDRESS_SPACE][STR_WIDTH];

     int depth;
     int width;
     int address_radix;
     int data_radix;
     int address_space_size;

     int content_flag;
     int end_flag;
     int index;
     int index2;

     int print_counter;
     int line_counter;

     unsigned int address;

     FILE * infile;
     FILE * outfile;

     if (argc < 3)
     {
	  printf("Usage: mif2array <infile> <outfile>\n");
	  exit(USAGE_ERROR);

     } // if (argc < 3)

     if ((infile = fopen(argv[1], "r")) == NULL)
     {
	  printf("Couldn't open file %s\n", argv[1]);
	  exit(INFILE_ERROR);

     } // if ((infile = fopen(argv[1], "r")) == NULL)

     if ((outfile = fopen(argv[2], "w")) == NULL)
     {
	  printf("Couldn't open file %s\n", argv[2]);
	  exit(OUTFILE_ERROR);

     } // if ((outfile = fopen(argv[2], "w")) == NULL)

     fprintf(outfile, "signal RAM : RAM_type :=\n");
     fprintf(outfile, "(");

     content_flag = 0;
     while ((fgets(in_buffer, BUF_SIZE, infile) != NULL) && content_flag == 0)
     {
	  residue = parse(in_buffer, dest_str);

	  if (strlen(dest_str) != 0)
	  {
	       if (strcmp(dest_str, "--") == 0)
	       {

	       }
	       else
	       {
		    if (strcmp(dest_str, "Depth") == 0)
		    {
			 residue = parse(residue, dest_str);
			 residue = parse(residue, dest_str);
			 depth = atoi(dest_str);
			 printf("Depth = %d\n", depth);
		    } 
		    else
		    {
			 if (strcmp(dest_str, "Width") == 0)
			 {
			      residue = parse(residue, dest_str);
			      residue = parse(residue, dest_str);
			      width = atoi(dest_str);
			      printf("Width = %d\n", width);
			 }
			 else
			 {
			      if (strcmp(dest_str, "Address_radix") == 0)
			      {
				   residue = parse(residue, dest_str);
				   residue = parse(residue, dest_str);
				   if (strcmp(dest_str, "HEX;") == 0)
					address_radix = 16;
				   else
					address_radix = 10;
				   printf("Address Radix = %d\n", address_radix);
			      } 			
			      else
			      {
				   if (strcmp(dest_str, "Data_radix") == 0)
				   {
					residue = parse(residue, dest_str);
					residue = parse(residue, dest_str);
					if (strcmp(dest_str, "HEX;") == 0)
					     data_radix = 16;
					else
					     data_radix = 10;
					printf("Data Radix = %d\n", data_radix);
						   } 			
				   else
				   {
					if (strcmp(dest_str, "Content") == 0)
					{
					     printf("%s\n", dest_str);
					}
					else
					{
					     if (strcmp(dest_str, "Begin") == 0)
					     {
						  printf("%s\n", dest_str);
						  content_flag = 1;

					     } // if (strcmp(dest_str, "Begin") == 0)
		
					} // if (strcmp(dest_str, "Content") == 0)

				   } // if (strcmp(dest_str, "Data_radix") == 0)

			      } // if (strcmp(dest_str, "Address_radix") == 0)

			 } // if (strcmp(dest_str, "Width") == 0)

		    } // if (strcmp(dest_str, "Depth") == 0)

	       } // if (strcmp(dest_str, "--") == 0)

	  } 
	  else
	  {
	       printf("Null string\n");
	       exit(NULL_STRING_ERROR);

	  } // if (strlen(dest_str) != 0)

     } // while ((fgets(in_buffer, BUF_SIZE, infile) != NULL) && content_flag == 0)

     for (index = 0; index < ADDRESS_SPACE; index++)
     {
	  for (index2 = 0; index2 < (width / 4); index2++)
	  {
	       microword_array[index][index2] = '0';

	  } // for (index2 = 0; index2 < (width / 4); index2++)

	  microword_array[index][width] = '\0';

     } // for (index = 0; index < ADDRESS_SPACE; index++)

     if (argc == 4)
     {
	  address_space_size = atoi(argv[3]);
     }
     else
     {
	  address_space_size = 1;
	  while (depth > address_space_size)
	       address_space_size = address_space_size * 2;

     } // if (argc == 4)

     end_flag = 0;
     while ((fgets(in_buffer, BUF_SIZE, infile) != NULL) && end_flag == 0)
     {
	  residue = parse(in_buffer, dest_str);

	  if (strlen(dest_str) != 0)
	  {

	       if (strcmp(dest_str, "--") == 0)
	       {

	       }
	       else
	       {
		    if (strcmp(dest_str, "[00..FF]:") == 0)
		    {

		    } 
		    else
		    {
			 if (strcmp(dest_str, "End;") == 0)
			 {
			     end_flag = 1;
			 }
			 else
			 {
			      chop(dest_str);
			      address = strtol(dest_str, '\0', 16);
			      residue = parse(residue, dest_str);
			      chop(dest_str);
			      strcpy(microword_array[address], dest_str);

			 } // if (strcmp(dest_str, "End;") == 0)

		    } // if (strcmp(dest_str, "[00..FF]:") == 0)

	       } // if (strcmp(dest_str, "--") == 0)
	  } 
	  else
 	  { 
 	       printf("Null string\n"); 
 	       exit(0); 

 	  } // if (strlen(dest_str) != 0)
     
     } // while ((fgets(in_buffer, BUF_SIZE, infile) != NULL) && end_flag == 0)

     line_counter = 1;
     print_counter = 0;
     for (index = 0; index < address_space_size; index++)
     {
	  print_counter++;
	  if (print_counter == 1)
	  {
	       if (line_counter != 1)
	       {
		    fprintf(outfile, ",");

	       } // if (line_counter != 1)
	       fprintf(outfile, "\n");

	  } // if (print_counter = 1)

	  fprintf(outfile, "X\"%s\"", microword_array[index]);
	  if (print_counter == 4)
	  {
	       print_counter = 0;
	       line_counter++;
	  }
	  else
	  {
	       fprintf(outfile, ", ");

	  } // if (print_counter == 4)

     } // for (index = 0; index < address_space_size; index++)
     fprintf(outfile, ");\n");

     fclose(infile);
     fclose(outfile);

} // main(int argc, char * argv[])

char *parse( char * src_str, char * dest_str)
{

     char * tmp_ptr;

     while (isspace(*src_str))
     {
	  src_str++;

     } // while (isspace(*src_str))

     tmp_ptr = src_str;

     while ((isgraph(*dest_str++ = *src_str++)));

     --dest_str;
     *dest_str = '\0';
     dest_str = tmp_ptr;
     return(src_str);
}

void chop( char * src_str)
{
     int len;

     len = strlen(src_str);
     src_str[len - 1] = '\0';

}
