library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity mux_2to1 is

  generic (
    WIDTH : integer := 16);

  port (
    D0_in         : in  std_logic_vector((WIDTH - 1) downto 0);
    D1_in         : in  std_logic_vector((WIDTH - 1) downto 0);
    Mux_Select_in : in  std_logic;
    Mux_out       : out std_logic_vector((WIDTH - 1) downto 0));

end mux_2to1;

architecture arch_mux_2to1 of mux_2to1 is

  signal D0         : std_logic_vector((WIDTH - 1) downto 0);
  signal D1         : std_logic_vector((WIDTH - 1) downto 0);
  signal Mux_Select : std_logic;
  signal Mux        : std_logic_vector((WIDTH - 1) downto 0);

begin  -- arch_mux_2to1

  D0         <= D0_in;
  D1         <= D1_in;
  Mux_Select <= Mux_Select_in;

  Mux_out <= Mux;

  Mux <= D0 when Mux_Select = '0' else
         D1 when Mux_Select = '1' else
         (others => '0');

end arch_mux_2to1;
