library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity mux_4to1 is

  generic (
    WIDTH : integer := 16);

  port (
    D0_in         : in  std_logic_vector((WIDTH - 1) downto 0);
    D1_in         : in  std_logic_vector((WIDTH - 1) downto 0);
    D2_in         : in  std_logic_vector((WIDTH - 1) downto 0);
    D3_in         : in  std_logic_vector((WIDTH - 1) downto 0);
    Mux_Select_in : in  std_logic_vector(1 downto 0);
    Mux_out       : out std_logic_vector((WIDTH - 1) downto 0));

end mux_4to1;

architecture arch_mux_4to1 of mux_4to1 is

  signal D0         : std_logic_vector((WIDTH - 1) downto 0);
  signal D1         : std_logic_vector((WIDTH - 1) downto 0);
  signal D2         : std_logic_vector((WIDTH - 1) downto 0);
  signal D3         : std_logic_vector((WIDTH - 1) downto 0);
  signal Mux_Select : std_logic_vector(1 downto 0);
  signal Mux        : std_logic_vector((WIDTH - 1) downto 0);

begin  -- arch_mux_4to1

  D0         <= D0_in;
  D1         <= D1_in;
  D2         <= D2_in;
  D3         <= D3_in;
  Mux_Select <= Mux_Select_in;

  Mux_out <= Mux;

  Mux <= D0 when Mux_Select = "00" else
         D1 when Mux_Select = "01" else
         D2 when Mux_Select = "10" else
         D3 when Mux_Select = "11" else
         (others => '0');

end arch_mux_4to1;
