library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity mux_8to1b is

  port (
    D0_in         : in  std_logic;
    D1_in         : in  std_logic;
    D2_in         : in  std_logic;
    D3_in         : in  std_logic;
    D4_in         : in  std_logic;
    D5_in         : in  std_logic;
    D6_in         : in  std_logic;
    D7_in         : in  std_logic;
    Mux_Select_in : in  std_logic_vector(2 downto 0);
    Mux_out       : out std_logic);

end mux_8to1b;

architecture arch_mux_8to1b of mux_8to1b is

  signal D0         : std_logic;
  signal D1         : std_logic;
  signal D2         : std_logic;
  signal D3         : std_logic;
  signal D4         : std_logic;
  signal D5         : std_logic;
  signal D6         : std_logic;
  signal D7         : std_logic;
  signal Mux_Select : std_logic_vector(2 downto 0);
  signal Mux        : std_logic;

begin  -- arch_mux_8to1b

  D0         <= D0_in;
  D1         <= D1_in;
  D2         <= D2_in;
  D3         <= D3_in;
  D4         <= D4_in;
  D5         <= D5_in;
  D6         <= D6_in;
  D7         <= D7_in;
  Mux_Select <= Mux_Select_in;

  Mux_out <= Mux;

  Mux <= D0 when Mux_Select = "000" else
         D1 when Mux_Select = "001" else
         D2 when Mux_Select = "010" else
         D3 when Mux_Select = "011" else
         D4 when Mux_Select = "100" else
         D5 when Mux_Select = "101" else
         D6 when Mux_Select = "110" else
         D7 when Mux_Select = "111" else
         '0';

end arch_mux_8to1b;
